struct pair
{
    struct pair* car;
    struct pair* cdr;
};

extern void* dream_error;
extern void error_too_many_args;
extern void error_too_few_args;
extern void error_expected_integer;
extern void error_expected_string;
extern struct pair* dream_free;
extern void* dream_memlimit;
extern struct pair dream_true;
extern struct pair dream_false;

#define BOOLEAN -5
#define INTEGER 3
#define STRING 9

#define CAR(PAIR) ((PAIR)->car)
#define CDR(PAIR) ((PAIR)->cdr)
#define TYPE(PAIR) ((int)CAR(PAIR) & 0xff)
#define EMPTY(PAIR) (PAIR==NULL)
#define INT_VALUE(PAIR) (int)(CDR(PAIR))
#define STRING_VALUE(PAIR) (char*)(CDR(PAIR))

#define FAIL(ERROR) { dream_error = &ERROR; return NULL; }

#define NO_MORE_ARGS(ARGS) \
    if( ARGS ) { FAIL(error_too_many_args); }

#define INSURE_ARGS(ARGS) \
    if ( EMPTY(ARGS) ) { FAIL(error_too_few_args); }

#define GET_INTEGER(VAR,ARGS)\
    INSURE_ARGS(ARGS);\
    if( !CAR(ARGS) || (TYPE(CAR(ARGS)) != INTEGER) ) { FAIL(error_expected_integer); }\
    VAR = INT_VALUE(CAR(ARGS));\
    ARGS = CDR(ARGS);

#define GET_STRING(VAR,ARGS)\
    INSURE_ARGS(ARGS);\
    if( !CAR(ARGS) || (TYPE(CAR(ARGS)) != STRING) ) { FAIL(error_expected_string); }\
    VAR = STRING_VALUE(CAR(ARGS));\
    ARGS = CDR(ARGS);

#define GET_NULLABLE_STRING(VAR,ARGS)\
    INSURE_ARGS(ARGS);\
    if( !CAR(ARGS) ) VAR = NULL;\
    else if( (TYPE(CAR(ARGS)) != STRING) ) { FAIL(error_expected_string); }\
    else VAR = STRING_VALUE(CAR(ARGS));\
    ARGS = CDR(ARGS);
